SimpleMp3LibraryTemp = {}
------------------------------------------------------
-- Library Functions
------------------------------------------------------

function LIBInfo(x, num)
    if (SimpleMp3Library) then
        if (x == 'song') then
            if (SimpleMp3Library[num].Title == 'None') then
                return string.gsub(SimpleMp3Library[num].Name, "^.+\\", "");
            else
                return SimpleMp3Library[num].Title;
            end
        elseif (x == 'artist') then
            if (SimpleMp3Library[num].Artist == 'None') then
                return SIMPLEMP3_UNK_ARTIST;
            else
                return SimpleMp3Library[num].Artist;
            end
        elseif (x == 'album') then
            if (SimpleMp3Library[num].Album == 'None') then
                return SIMPLEMP3_UNK_ALBUM;
            else
                return SimpleMp3Library[num].Album;
            end
        elseif (x == 'genre') then
            if (SimpleMp3Library[num].Genre == 'None') then
                return SIMPLEMP3_UNK_GENRE;
            else
                return SimpleMp3Library[num].Genre;
            end
        elseif (x == 'bitrate') then
            if (SimpleMp3Library[num].BitRate == 'None') then
                return SIMPLEMP3_UNK_BITRATE;
            else
                return SimpleMp3Library[num].BitRate;
            end
        elseif (x == 'name') then
            return SimpleMp3Library[num].Name;
        elseif (x == 'name2') then
            return string.gsub(SimpleMp3Library[num].Name, "^.+\\", "");
        elseif (x == 'length') then
            return SimpleMp3Library[num].Length;
        elseif (x == 'length2') then
            return Time(SimpleMp3Library[num].Length);
        end
    else
        return SIMPLEMP3_UNK
    end
end

function LibraryDisplay(num)
    if (Smp3_Save.UseTags == true) then
        return LIBInfo('song', num) .. " " .. "|cFFFFFFFF" .. LIBInfo('artist', num) .. " " .. "|r" .. LIBInfo('album', num) .. " " .. "|cFFFFFFFF" .. LIBInfo('genre', num) .. " " .. "|r" .. LIBInfo('bitrate', num) .. "k " .. "|cFFFFFFFF" .. LIBInfo('length2', num) .. "|r";
    else
        return LIBInfo('name2', num) .. " " .. LIBInfo('length2', num);
    end
end

-- Library Onshow tells it to update
function SimpleMp3Library_OnShow()
    if (Smp3_Save.PlaySounds == true) then
        PlaySound("igCharacterInfoOpen");
    end
    Smp3_Save.wasVisibleLIB = true;
    SimpleMp3Library_Update()
end

function SimpleMp3Library_OnHide()
    if (Smp3_Save.PlaySounds == true) then
            PlaySound("igCharacterInfoClose");
    end
    Smp3_Save.wasVisibleLIB = false;
end

 -- When the scrollbar is changed so shall the list
function SimpleMp3Library_OnValueChanged()
    SimpleMp3Library_Update()
end
-- First load to set total population for the slider
function SimpleMp3Library_OnLoad()
    local SliderVar;
    this:RegisterForDrag("LeftButton");
    SliderVar = getglobal("SimpleMp3LibraryForm" .. "LibrarySlider");
    if (SimpleMp3Library) then
        SliderVar:SetMinMaxValues(1, SliderMax(table.getn(SimpleMp3Library), Smp3_Save.LIBVisibleSlots));
    end
end

function SimpleMp3Library_OnEvent()
end

-- Library form populates the list according to window size
function PopulateLibrary()
    local LabelVar, SliderVar;
    SliderVar = getglobal("SimpleMp3LibraryForm" .. "LibrarySlider");
    MaxLibraryNum = table.getn(SimpleMp3Library);

    if (MaxLibraryNum == 1) then
        LabelVar = getglobal("SimpleMp3LibraryForm" .. "LibraryPanel" .. 1);
        LabelVar:SetText(SliderVar:GetValue() + 0 .. ". " .. LibraryDisplay(SliderVar:GetValue() + 0));
        elseif (Smp3_Save.LIBVisibleSlots <= MaxLibraryNum) then
        for i=1,Smp3_Save.LIBVisibleSlots do
            LabelVar = getglobal("SimpleMp3LibraryForm" .. "LibraryPanel" .. i);
            LabelVar:SetText(SliderVar:GetValue() + (i - 1) .. ". " .. LibraryDisplay(SliderVar:GetValue() + (i - 1)));
        end
    else
        for i=1,MaxLibraryNum do
            LabelVar = getglobal("SimpleMp3LibraryForm" .. "LibraryPanel" .. i);

            if (i > MaxLibraryNum) then
                return;
            end

            -- Debugging purposes while fixing playlist resizing issue
            -- DEFAULT_CHAT_FRAME:AddMessage(SliderVar:GetValue() .. " " .. i .. " " .. SimpleMp3Library[(SliderVar:GetValue() + i) - 1].Name);
            LabelVar:SetText(SliderVar:GetValue() + (i - 1) .. ". " .. LibraryDisplay(SliderVar:GetValue() + (i - 1)));
        end
    end
end

-- Library update (text show/hide routine)
-- This tells the resizable window how many slots are viewable at that size
function SimpleMp3Library_Update()
    if (SimpleMp3Library) then
        MaxLibraryNum = table.getn(SimpleMp3Library);
        local fheight = SimpleMp3LibraryForm:GetHeight()
        local SliderVar;
        SliderVar = getglobal("SimpleMp3LibraryForm" .. "LibrarySlider");

        for i = 1, 25 do
            if (MaxLibraryNum >= i) then
                if ((i * 14) + 37.8 < fheight) then
                    x = 'SimpleMp3LibraryFormLibraryPanel' .. i .. ':Show()'
                    RunScript(x)
                    SliderVar:SetMinMaxValues(1, SliderMax(table.getn(SimpleMp3Library), (i-1)));
                    Smp3_Save.LIBVisibleSlots = i;
                else
                    x = 'SimpleMp3LibraryFormLibraryPanel' .. i .. ':Hide()'
                    RunScript(x)
                end
            else
                x = 'SimpleMp3LibraryFormLibraryPanel' .. i .. ':Hide()'
                RunScript(x)
            end
        end
    end

    -- Debugging purposes while fixing playlist issues
    -- DEFAULT_CHAT_FRAME:AddMessage(fheight);

    PopulateLibrary()
end

-- Function for when something in the Library is clicked
function SimpleMp3Library_OnClick(MouseButton, Number)
    if (SimpleMp3Library) then
        local SliderVar;
        SliderVar = getglobal("SimpleMp3LibraryForm" .. "LibrarySlider");
        LIBCurrent = (SliderVar:GetValue() + Number - 1);

        if (MouseButton == 'LeftButton' and IsControlKeyDown()) then
            if (Smp3_Save.PlaySounds == true) then
                PlaySound("igMiniMapZoomIn");
            end
            tinsert(SimpleMp3LibraryTemp, SimpleMp3Library[LIBCurrent]);
            -- DEFAULT_CHAT_FRAME:AddMessage("Added " .. SimpleMp3LibraryTemp[LIBCurrent].Name);
        elseif (MouseButton == 'LeftButton' and IsShiftKeyDown()) then
            if (Smp3_Save.PlaySounds == true) then
                PlaySound("igMiniMapZoomIn");
            end
            if (isPlaying) then
                SimpleMp3Form_StopMusic();
            end
            isPlayingDemo = true;
            Smp3_Length = LIBInfo('length', LIBCurrent);
            SimpleMp3Form_StartMusic(LIBInfo('name', LIBCurrent), LIBInfo('song', LIBCurrent), LIBInfo('artist', LIBCurrent), LIBInfo('album', LIBCurrent), LIBInfo('length2', LIBCurrent), 'demo', true); -- FIXME
        elseif (MouseButton == 'LeftButton') then
            if (Smp3_Save.isShuffled == true) then
                DEFAULT_CHAT_FRAME:AddMessage(SIMPLEMP3_CANT_ADD);
            else
                if (Smp3_Save.PlaySounds == true) then
                    PlaySound("igMiniMapZoomIn");
                end
                tinsert(Smp3_Save.SimpleMp3PlayList, SimpleMp3Library[LIBCurrent]);
            end
        end
        SimpleMp3Library_Update()
    end
end

-- Exit Button
function SimpleMp3Library_OnExitClick()
    SimpleMp3LibraryForm:Hide();
end

-- Library scroll function
function SimpleMp3Library_OnMouseWheel(Direction)
    local SliderVar;
    SliderVar = getglobal("SimpleMp3LibraryForm" .. "LibrarySlider");

    if (Direction == 1) then
        SliderVar:SetValue(SliderVar:GetValue() - 1);
    else
        SliderVar:SetValue(SliderVar:GetValue() + 1);
    end
end

-- Function to Add All songs to the PlayList
function AddAll_button()
    for i = 1, table.getn(SimpleMp3Library) do
           tinsert(Smp3_Save.SimpleMp3PlayList, table.getn(Smp3_Save.SimpleMp3PlayList) + 1, SimpleMp3Library[i]);
    end
    SimpleMp3Form_ResetDisplay(PLInfo('name', Smp3_Save.Current), PLInfo('song', Smp3_Save.Current), PLInfo('artist', Smp3_Save.Current), PLInfo('album', Smp3_Save.Current), PLInfo('length2', Smp3_Save.Current), Smp3_Save.Current, false);
    SimpleMp3Library_Update()
    collectgarbage();
end

-- Function to Add All Selected songs to the PlayList
function AddSelected_button()
    if (SimpleMp3LibraryTemp == nil) then
        return
    end
    if (Smp3_Save.isShuffled == true) then
        DEFAULT_CHAT_FRAME:AddMessage(SIMPLEMP3_CANT_ADD);
    else
        for i = 1, table.getn(SimpleMp3LibraryTemp) do
            tinsert(Smp3_Save.SimpleMp3PlayList, table.getn(Smp3_Save.SimpleMp3PlayList) + 1, SimpleMp3LibraryTemp[i]);
            --DEFAULT_CHAT_FRAME:AddMessage("Added " .. SimpleMp3LibraryTemp[i].Name);
        end
        for i = 1, table.getn(SimpleMp3LibraryTemp) do
            tremove(SimpleMp3LibraryTemp)
        end
        collectgarbage();
    end
end
